#include "corpinc.h"     


struct blookup {
	char code[MAX_CODE+1];
	struct bibhdr hdr;
	int item;
};

struct blookup *lk;
struct bibentry *items;

int nbibs;
int nt, nb;    
int nextitem;
long nseek;                  

#define MAXBTEXT 5000
#define MAXBITEM 20000


void ProcessInput(FILE*);
BOOL ProcessItem(FILE*,struct blookup *);
char* SpokenItem(char *,struct blookup *,FILE*);
char* WrittenItem(char *,struct blookup *,FILE*);
void AddBib1(char*,FILE*);
void AddBib2(char*,FILE*);


void Bibliography(void)
{
	FILE *f; char code[MAX_CODE+1]; char id[12];
	char path[_MAX_PATH];
	lk=malloc(MAXBTEXT*sizeof (struct blookup));
	items=malloc(MAXBITEM*sizeof (struct bibentry));
	nextitem=0;
	strcpy(path,etcpath);
	strcat(path,bibname);    
	f=fopen(path,"r"); 
	if (f==NULL) {
		corperr("Cannot find bibliography file %s",path);
		return;
	}
	ProcessInput(f);
	fclose(f);
	strcpy(path,etcpath);
	strcat(path,PBIBNAME);
	f=fopen(path,"w");  
	nseek=0;
	rewind(fIndex);
	while (fscanf(fIndex,"%s %s %s\n",code,id,path)==3) 
		nseek+=sizeof (struct bibhdr);
	rewind(fIndex);
	while (fscanf(fIndex,"%s %s %s\n",code,id,path)==3) 
		AddBib1(code,f);
	rewind(fIndex);
	while (fscanf(fIndex,"%s %s %s\n",code,id,path)==3) 
		AddBib2(code,f);
	printf("Data for %d/%d texts\n",nb,nt);   
	free(lk);
	free(items);
	fclose(f);
}		

#define LABEL "<label>"	    
#define XLABEL "</label>"
#define ITEM "<item>"
#define HI "<hi>"
#define XHI "</hi>"
#define XITEM "</item>"
#define P "<p>"
#define XP "</p>"
#define LIST "<list"
#define XLIST "</list>"

	
void ProcessInput(FILE *f)
{                                     
	int i=0;
	while (ProcessItem(f,&lk[i])) {
                 i++;
        }         
	nbibs=i;
	printf("Found %d entries\n",nbibs);
}                       

#define MAXBIBITEM 1000

char buffer[MAXBIBITEM];
long pos;

			
char* Refresh(char* p,FILE* f)
{
	int x;
	fseek(f,pos+(p-buffer),SEEK_SET);
	pos+=(p-buffer);
	x=fread(buffer,1,sizeof buffer-1,f);
	buffer[x]=0;    
	return buffer;
}	
	
BOOL ProcessItem(FILE *f,struct blookup *bl)
{                         
	char *p, *p1, *p2; int x;
	pos=ftell(f);
	x=fread(buffer,1,sizeof buffer-1,f);
	buffer[x]=0;
	p=strstr(buffer,LABEL);
	if (!p) return FALSE;
	p+=sizeof(LABEL)-1;
	strncpy(bl->code,p,3);
	bl->code[3]=0;
	bl->item=nextitem;
	printf("%s\n",bl->code);
	p=strstr(p,ITEM);
	if (!p) return FALSE;
	p+=sizeof(ITEM)-1;
	p1=strstr(p,HI);
	p2=strstr(p,P);
	if (p1==NULL || (p1 > p2 && p2 != NULL))
		p=SpokenItem(p2,bl,f);
	else
		p=WrittenItem(p1,bl,f);	
	fseek(f,pos+(p-buffer),SEEK_SET);
	return TRUE;
}	    

char* WrittenItem(char* p,struct blookup *bl,FILE *f)
{
	char* pp;
	bl->hdr.type=0;
	bl->hdr.nrows=2;
	p+=sizeof(HI)-1;
	items[nextitem].name=pos+(p-buffer);
	pp=strstr(p,XHI);
	items[nextitem].namelen=pp-p;
	nextitem++;
	p=pp+sizeof(XHI)-1;
	while (isspace(*p)) p++;
	items[nextitem].name=pos+(p-buffer);
	pp=strstr(p,XITEM);
	items[nextitem].namelen=pp-p;
	nextitem++;
	return pp+sizeof(XITEM)-1;
}	                

char* SpokenItem(char* p,struct blookup *bl,FILE *f)
{                   
	char *pp, *pp1;
	int ni=nextitem;
	bl->hdr.type=1;
	p+=sizeof(P)-1;
	items[nextitem].name=pos+(p-buffer);
	pp=strstr(p,XP);
	pp1=strstr(p,LIST);
	if (pp1<pp || pp==NULL) pp=pp1; 
	items[nextitem].namelen=pp-p;
	nextitem++;                
	while(1) {
		char *p1,*p2;
		p1=strstr(p,XLIST);
		p2=strstr(p,LABEL);
		if (p2==NULL||(p1<p2 && p1 != NULL)) break;
		p=p2;
		p+=sizeof(LABEL)-1;
		items[nextitem].name=pos+(p-buffer);
		pp=strstr(p,XLABEL);
		items[nextitem].namelen=pp-p;
		nextitem++;
		p=strstr(pp,ITEM);
		p+=sizeof(ITEM)-1;
		items[nextitem].name=pos+(p-buffer);
		pp=strstr(p,XITEM);
		items[nextitem].namelen=pp-p;
		nextitem++;
		p=pp+sizeof(XITEM)-1;
		p=Refresh(p,f);
	}	
	bl->hdr.nrows=nextitem-ni;
	p=strstr(p,XITEM);
	p+=sizeof(XITEM)-1;
	return p;
}		
	
	

void AddBib1(char* code,FILE* f)
{
	int i;
	struct bibhdr b;
	for (i=0;i<nbibs;i++)
		if (!strcmp(lk[i].code,code)) break;
	if (i<nbibs) {
		b.type=lk[i].hdr.type;
		b.nrows=lk[i].hdr.nrows;
		b.seek=nseek;
		nseek+=b.nrows*sizeof (struct bibentry);
		nb++;
	} else {
		b.type=-1;   
		b.seek=nseek;
		b.nrows=0;
	}		
	fwrite(&b,sizeof b,1,f);
	nt++;
}	     
	
void AddBib2(char* code,FILE* f)
{
	int i,j;
	for (i=0;i<nbibs;i++)
		if (!strcmp(lk[i].code,code)) break;
	if (i<nbibs) {
		for (j=0;j<lk[i].hdr.nrows;j++) 
			fwrite(&items[j+lk[i].item],sizeof (struct bibentry),1,f);	
	}
}		
		
	
	
	
		
