#include "corpinc.h"

enum _st ch_st(unsigned char);
enum _st el_st(char*);
enum _st cr_st(char*);
unsigned char WordFold(unsigned char);
int ClassifyPOS(char*);
void s_init_string(char*,long);
void init_sgml();
BOOL get_sgml();
void WPush(char*,int);
void WPop(char**,int*);
void WInit();
BOOL WAdStream(struct stream *, sara_ulong, WORDNO, int, BOOL);
void ScoreHW(char*);
int chash(const char*);
int AddLemma(const char*,int,const char*);
void Attval(char*);
extern char lemma[MAXWORD];

BOOL isspace0(char);
void ScoreWord(int);
void colloc_sgml();
BOOL CollocString(char*,long,long,int,int);
int QuickFrequency(const char*);
double score(int,int);
long NUsages();
double cform(int,int,int,int);
void GetFTable(char*);
//--------------------------------------------------------------- 
// Iterate
//
// Iterate calls the function that is its argument for every entry
// in the index. 
//---------------------------------------------------------------


void Iterate(void pf(char*,sara_int,sara_int,sara_ulong,WORDNO))
{
	int h;
	for (h=0;h<hashrange;h++) {
		int k=0; char path[_MAX_PATH]; char w[MAXWORD];
		sara_int type, extra;
		w[0]=0;
		do {
			FILE* fInd; int i, j, n;
			IndexFile(h,k,path);
			fInd=fopen(path,"r");
			if (fInd==NULL) break;
			fread(&header,sizeof header,1,fInd);
			fread(dict,sizeof (struct dicent),header.ndict,fInd);
			fread(locs,sizeof (struct locent),header.nill,fInd);
			fread(words,1,header.nbytes,fInd);
			fclose(fInd);
// process word overflow here
			if (header.ndict==0) 
				n=header.nill;
			else
					n=dict[0].first;
			for (j=0;j<dict[0].first;j++) {
				pf(w,type,extra,locs[j].lcode,locs[j].word);
			}
			for (i=0;i<header.ndict;i++) {
				strcpy(w,words+dict[i].dwd);
				if (i+1 < header.ndict) 
					n=dict[i+1].first;
				else
					n=header.nill;
				type=dict[i].type;
				extra=dict[i].extra;
				for (j=dict[i].first;j<n;j++) {
					pf(w,type,extra,locs[j].lcode,locs[j].word);
				}
			}
			k++;
		} while (header.bOS);
	}
}

extern struct sgml record;
extern BOOL bHead;

#define MAXKTEST 100

char tbuff[MAXWORD+5];
int t;
long pp, ph; int nw1, nw2;
int ncoll;
int ncollmax=0;
int nhits, scs; 
BOOL bEnd;
int ktest;
static char* test[MAXKTEST]; BOOL bTestMode;
int method, limit, maxs; double minz;
int hapax;
static struct regexp *re;
int chtab[0x400];
extern char sElement[MAXNAME+1];


#define NCOLLMAX 2000

struct _ct {
	char w[MAXWORD];
	int x;
	int freq;
	double score;
	int next;
} *colltab;

int qc(const void* v1,const void* v2)
{
	struct _ct* c1=(struct _ct*) v1;
	struct _ct* c2=(struct _ct*) v2;
	double c=c2->score-c1->score;
	if (c>0) return 1;
	else if (c<0) return -1;
	else return 0;
}

void CTab(int n,char** w,int* f, double* s)
{
	*w=colltab[n].w;
	*f=colltab[n].x;
	*s=colltab[n].score;
}

int GetType(char* scope)
{
	int i;
	for (i=0;i<nelts;i++) {
		if (!SGMLComp(eltab[i].name,scope)) continue;
		return eltab[i].eltype;
	}
	return 0;
}

void InitHash(int max)
{
	int i; char path[_MAX_PATH]; char line[800];
	FILE* f;
	for (i=0;i<0x400;i++) chtab[i]=-1;
	GetFTable(path);
	f=fopen(path,"r");
	for (i=0;i<max;i++) {
		char w[MAXWORD]; int f1; int h;
		if (!fgets(line,sizeof line,f)) break;
		h=chash(w);
		if (chtab[h]==-1) chtab[h]=i;
		else {
			int k=chtab[h];
			while (colltab[k].next != -1) k=colltab[k].next;
			colltab[k].next=i;
		}
		sscanf(line,"%[^\t]\t%d %*d",w,&f1);
		strcpy(colltab[i].w,w);
		colltab[i].x=0;
		colltab[i].freq=f1;
		colltab[i].next=-1;
	}
	ncoll=max;
	fclose(f);
}

#define SEEDHASH 4000

int MakeCTab(char* name,int w1,int w2,char* pattern)
{
	char* sol; struct locent1 l; FILE* f; 
	int m, i, ncoll0;
	re=ParseRegExp(pattern);
	sol = GetQPath(name); 
	ncoll=0; 
	if (ncollmax > 0) return -1;
	colltab=(struct _ct *) malloc((NCOLLMAX+SEEDHASH)*sizeof (struct _ct));
	ncollmax=NCOLLMAX+SEEDHASH;
	InitHash(SEEDHASH);
	if ((f = fopen(sol, "r")) == NULL) {
		syslog(LOG_ERR, "Couldn't open %s\n", name);
		return -1;
	}
	fseek(f,0,SEEK_END);
	nhits=ftell(f)/sizeof l;
	scs=NUsages();
	fseek(f,0,SEEK_SET);
	syslog(LOG_DEBUG,"Started table");
	while (fread(&l,sizeof(l),1,f)) {
		sara_long l1, l2; char path[_MAX_PATH]; char id[10]; 
		FILE* fT; char* s;
		l1 = (w1==0?l.pos:LastSGML(l.word - w1, l.lcode, defscope, ID_TAGO));
		l2 = NextSGML(l.word + w2, l.lcode, defscope, ID_TAGO); // sloppy
//		l1 = (w1==0?l.pos:LastSGML(l.word, l.lcode, defscope, ID_TAGO));
//		l2 = NextSGML(l.word, l.lcode, defscope, ID_TAGO); 
		s=malloc(l2-l1+1);
		GetDocPath(l.lcode, id, path);
		fT=fopen(path,"r");
		fseek(fT,l1,SEEK_SET);
		fread(s,1,l2-l1,fT);
		s[l2-l1]=0;
		fclose(fT);
		bTestMode=FALSE;
		CollocString(s,l1,l.pos,w1,w2);
		free(s);
	}
	fclose(f);
	syslog(LOG_DEBUG,"Looking up frequencies");
	for (i=0;i<ncoll;i++) {
		int f=colltab[i].freq; double s=0;
		if (f==0 && colltab[i].x > hapax) {
			f=QuickFrequency(colltab[i].w);
			assert(f != 0);
		}
		if (colltab[i].x <= hapax) colltab[i].x=0;
		if (colltab[i].x > 0 && f > 0)
			s=score(colltab[i].x,f);
		else 
			s=-1000;
		colltab[i].score=s;
		colltab[i].freq=f;
	}
	syslog(LOG_DEBUG,"Sorting");
	qsort(colltab,ncoll,sizeof (struct _ct),qc);
	for (i=0;i<ncoll;i++) 
		if (colltab[i].x==0) break;
	ncoll0=i;
	syslog(LOG_DEBUG,"Done");
	switch (limit) {
	case 0:
		m=maxs;
		break;
	case 1:
		for (i=0;i<ncoll0;i++)
			if (colltab[i].score<minz) break;
		m=i;
	}
	return min(m,ncoll0);
}


BOOL bRet;

BOOL CollocString(char* s,long pos,long poshit,int w1,int w2)
{
	bRet=FALSE;
	ph=poshit; nw1=w1; nw2=w2; pp=-1;
	s_init_string(s,pos); 
	init_sgml();
	record.id=HDRPOS; bEnd=FALSE;
	WInit();
	while (!bEnd && get_sgml())
		colloc_sgml();
	return bRet;
}	




void IncrementScore(char* w, int extra)
{
	char hw[MAXWORD];
	int fi;
	fi=IsFrob(w);
	if (fi==-1) {
		if (!lemmata(w,extra,hw,FALSE)) return;
		ScoreHW(hw);
	} else {
		int i;
		for (i=0;i<nfrobpos;i++) {
			if (fptab[i].frob != fi) continue;
			if (!lemmata(fptab[i].word,extra,hw,TRUE)) continue;
			ScoreHW(hw);
		}
	}
}

int chash(const char* c)
{
	int h=c[0] & 0x1F;
	if (c[0]) h+=(c[1]&0x1F) << 5;
	return h;
}

void ScoreHW(char* hw)
{
	int k, n, h; int* p; int kt;
	if (!pMatch(hw,re)) return;
	h=chash(hw);
	kt=chtab[h];
	p=&chtab[h];
	while (kt != -1) {
		if (!strcmp(hw,colltab[kt].w)) break;
		p=&colltab[kt].next;
		kt=colltab[kt].next;
	}
	if (kt==-1) {
//		f=QuickFrequency(hw);
//		assert(f != 0);
//		if (f==0) return;
		k=0;
	}
	else {
//		f=colltab[i].freq;
		k=colltab[kt].x;
	} 
	k++;
//	s=score(k,f);
	if (kt != -1) {
		colltab[kt].x=k;
//		colltab[i].score=s;
		return;
	}
	if (ncoll >= ncollmax) {
		int p0;
		ncollmax+=NCOLLMAX;
		p0=((char*) p)-((char*)colltab);
		colltab=realloc(colltab,ncollmax*sizeof (struct _ct));
		p=(int*) (((char*) colltab)+p0);
	}
	n=ncoll;
	ncoll++;
	strcpy(colltab[n].w,hw);
	colltab[n].x=k;
	colltab[n].next=-1;
	colltab[n].freq=0;
	*p=n;
//	colltab[n].score=s;
//	colltab[n].freq=f;
}

int nwo;

void ScoreColloc(char* w,long pos,int extra)
{
	int i;
	if (pos < ph) {
		WPush(w,extra);
		return;
	}
	if (pos==ph) {
		char* ww; int ee;
		for (i=1;i<=nw1;i++) {
			WPop(&ww,&ee);
			IncrementScore(ww,ee);
		}
		nwo=1;
		return;
	}
	if (nwo  <= nw2) {
		IncrementScore(w,extra);
		nwo++;
	}
	if (nwo>=nw2) bEnd=TRUE;
}

int ScoreLemma(const char* s,int w,const char* l)
{
	if (l[0]==0) return 0;
	return AddLemma(s,w,l);
}

void ScoreWord(int extra)
{
	tbuff[t]=0;
	if (nlt > 0) extra+=10000*ScoreLemma(tbuff,extra,lemma);
	ScoreColloc(tbuff,pp,extra);
	t=0; pp=-1;
}


void colloc_sgml()
{                   
	char *s;
	switch (record.type)
	{
	case SG_STARTTAG:     
		while (t>0 && tbuff[t-1]==' ' && !bNoPos) t--;
		if (t>0 && el_st(record.name)==ST_SPACE)
			ScoreWord(record.id);
		if (!bNoPos && IsWTag(record.name)) {
			record.id=0;
			lemma[0]=0;
			break;
		}
	    break;
	case SG_ENDTAG:
		while (t>0 && tbuff[t-1]==' ' && !bNoPos) t--;
		if (t>0 && el_st(record.name)==ST_SPACE)
			ScoreWord(record.id);
		record.id=HDRPOS;
	    break;            
	case SG_CHAR:
		if (ch_st(record.name[0])==ST_DEL) break;
		if (t==0 && isspace0(record.name[0])) break;
		if (t>0 && ch_st(record.name[0])==ST_SPACE && record.id==HDRPOS)
		{
			ScoreWord(HDRPOS);
			break; /* losing punctuation, which is fine with me! */
		}	
		if (pp<0) pp=record.pos;
		if (record.name[0]==13) break;
		if (isspace0(record.name[0])) record.name[0]=' ';
		if (t < MAXWORD+4) 
			tbuff[t++]=WordFold(record.name[0]);
		break;
	case SG_CREF:
		if (cr_st(record.name)==ST_DEL) break;
		if (!bNoPos && t==0 && cr_st(record.name)==ST_SPACE) break;
		if (t>0 && cr_st(record.name)==ST_SPACE && record.id==HDRPOS)
		{
			ScoreWord(HDRPOS);
			break; /* losing punctuation, which is fine with me! */
		}	
		if (pp<0) pp=record.pos;
		s=record.name;               
		if (t+strlen(s)+2 >= MAXWORD+4) break;
		tbuff[t++]=CSTART_CHAR;
		while (*s)
			tbuff[t++]=*(s++); 
		tbuff[t++]=CEND_CHAR;		
		break;		         
	case SG_ATT:
		if (IsPosTag(sElement,record.name)) 
		{
			record.id=ClassifyPOS(record.val);
			break;
		}  
		if (IsLemmaTag(sElement,record.name))
		{
			strcpy(lemma,record.val);
			Attval(lemma);
		}
		break;
	}			    
	return;
}			       

double score(int k,int f)
{
	double p=((double) f)/scs;
	int d=(nw1+nw2)*nhits;
	return cform(k,f,d,nhits);
}

#define MAXS 10

struct _ws {
	char w[MAXWORD];
	int e;
} stack[MAXS];

int wsp;

void WInit()
{
	wsp=0;
}

void WPush(char* w,int e) 
{
	strcpy(stack[wsp].w,w);
	stack[wsp].e=e;
	wsp++;
	if (wsp >= MAXS) wsp=0;
}

void WPop(char** w,int* e)
{
	wsp--;
	if (wsp < 0) wsp=MAXS-1;
	*w=stack[wsp].w;
	*e=stack[wsp].e;
}

void ACScore(char* q,int kwin1,int kwin2,int meth,char* cql,long* ns,double* sc)
{
	int x, f, d, om; double p;
	char* sol; FILE* fi; int nhits;
	sol = GetQPath(q); 
	if ((fi = fopen(sol, "r")) == NULL) {
		syslog(LOG_ERR, "Couldn't open %s\n", q);
		return;
	}
	fseek(fi,0,SEEK_END);
	nhits=ftell(fi)/sizeof (struct locent1);
	fclose(fi);
	*ns=x=colloc_score(q,cql,kwin1,kwin2,&f);
	d=(kwin1+kwin2)*nhits;
	p=f/(double) NUsages();
	om=method;
	method=meth;
	*sc=cform(x,f,d,nhits);
	method=om;
//	*sc=x-p*d;
//	*sc = *sc/sqrt(d*p*(1-p));
}

double cform(int x,int f,int d,int nhits)
{
	double s; double p=f/(double) NUsages();
	assert(d > 0); assert(p > 0);
	switch (method) {
	case 0: {  // z score
		s=x-p*d;
		s=s/sqrt(d*p*(1-p));
		break;
			}
	case 1: {
		int a=x; 
		int b=f;
		int c=nhits;
		int d=NUsages()-a-b-c;
		s=log(a*(double) NUsages()/(a+b)*(a+c))/log(2);
			}
	}
	return s;
}




// surely better to use the index here?
/*
void CTabThin(char* oldn,char* newn,int w1,int w2,char* node,int* ns,int* nt)
{
	char *p1, *p2; struct locent1 l; char* c;
	FILE *fin, *fout;
	p1=GetQPath(oldn);
	p2=GetQPath(newn);
	fin=fopen(p1,"r");
	fout=fopen(p2,"w");
	*ns=*nt=0;
	test[0]=strtok(node," ");
	ktest=1;
	while (c=strtok(NULL," ")) {
		if (ktest >= MAXKTEST) break;
		test[ktest++]=c;
	}
	while (fread(&l,sizeof(l),1,fin)) {
		sara_long l1, l2; char path[_MAX_PATH]; char id[20];
		FILE* fT; char* s;
		l1 = (w1==0?l.lcode:LastSGML(l.word - w1, l.lcode, defscope, ID_TAGO));
		l2 = NextSGML(l.word + w2, l.lcode, defscope, ID_TAGO);
		s=malloc(l2-l1+1);
		GetDocPath(l.lcode, id, path);
		fT=fopen(path,"r");
		fseek(fT,l1,SEEK_SET);
		fread(s,1,l2-l1,fT);
		s[l2-l1]=0;
		fclose(fT);
		bTestMode=TRUE;
		if (CollocString(s,l1,l.pos,w1,w2)) 
		{
			fwrite(&l,sizeof l,1,fout);
			(*ns)++;
		}
		free(s);
	}
	fclose(fin);
	fclose(fout);
}
*/

void CTabThin(char* oldn,char* newn,int w1,int w2,char* node,int* ns,int* nt)
{
	char *p1, *p2; struct locent1 l; 
	FILE *fin, *fout; struct stream *s; 
//	char* c;
	p1=GetQPath(oldn);
	p2=GetQPath(newn);
	fin=fopen(p1,"r");
	fout=fopen(p2,"w");
	*ns=*nt=0;
//	test[0]=strtok(node," ");
//	ktest=1;
//	while (c=strtok(NULL," ")) {
//		if (ktest >= MAXKTEST) break;
//		test[ktest++]=c;
//	}
	s=MakeLemmaStream(node);
	while (fread(&l,sizeof(l),1,fin)) {
		WORDNO      w = l.word - w1; BOOL bRW=FALSE;
		if (!WAdStream(s, l.lcode, w, -1, FALSE))
			break;
		if (s->lcode == l.lcode && s->wpos == l.word)
		{
			bRW=TRUE;
			if (!WAdStream(s,l.lcode,l.word+1,-1,FALSE)) 
				break;
		}
		if (s->lcode == l.lcode && s->wpos != l.word && s->wpos <= l.word + w2) {
			fwrite(&l,sizeof l,1,fout);
			(*ns)++;
		} else if (bRW) RewindStream(s);
	}
	fclose(fin);
	fclose(fout);
	FreeStream(s);
}

CTabOptions(int m,int l,char* p,int hap)
{
	method=m;
	limit=l;
	hapax=hap;
	maxs=100; minz=4.5; 
	switch (l) {
	case 0:
		maxs=atoi(p);
		break;
	case 1:
		minz=atof(p);
		break;
	}
}

BOOL isspace0(char c)
{
	return 0 <= c && c <= 32;
}

void CTabFree()
{
	free(colltab);
	ncollmax =0;
}

