#include "corpinc.h"

/* changed stricmp to _stricmp */





                                







void AddWords(unsigned,FILE*,int*);                                



void MakeStreambase(char*,char*,char*,int*);

BOOL SetSubCorpus(const char*);

BOOL SetSubCorpusND(const char*);

int SBCount(struct locent*,int);

void SCReadAll();



void PackDict(FILE*,FILE*,long);



int WordTable(const char*);

void WTSave();

void WTFree();

void WTLoad();

void WTInit();



void MakeLemmaTable();



BOOL Punct(int);

#ifdef FROB

void FMUL(char*,int,int);

void FMWrite();

#endif

void AllSCDic();









long nuses; double nuses1;







int nwt=0;

int nfmtab=0;

        







struct dhead dh;





void mysort1(const char*,const char*,int*);

void mysort2(const char*,const char*,int);



int qad[256*256];        



void XDic();



static unsigned int uc0;



void Dictionary()

{

	int i;

	WTInit();

	for (i=0;i<LemmaNSchemes();i++) {

		if (!LemmaIsEnabled(i)) continue;

		LemmaSetScheme(i,FALSE);

		g_uc0=LemmInfo()[2];

		XDic("all");

	}

	WTSave();

// now reregister all subcorpora

	AllSCDic();

}



void AllSCDic()

{

	int i, n;

	SCReadAll();

	n=SCCount()-1;

	for (i=0;i<n;i++)

		SCDictionary(SCName(i));

}

	



void SCDictionary(const char* name)

{

	int i;

	if (!SetSubCorpusND(name)) {

		corperr("No such subcorpus\n");

		return;

	}

	corperr("Subcorpus %s\n",name);

	WTLoad();

	for (i=0;i<LemmaNSchemes();i++) {

		if (!LemmaIsEnabled(i)) continue;

		LemmaSetScheme(i,FALSE);

		g_uc0=LemmInfo()[2];

		XDic(name);

	}

	WTFree();

}



void XDic(char* name)

{

 	int nd; int i; char dpath[_MAX_PATH];          

//	double mean, v, sd;

/* Make and save the .* wordlist with frequencies.	

  First make a text copy */

    char msg[100];

	char path[_MAX_PATH], path1[_MAX_PATH]; FILE *f, *f1; 

	char path2[_MAX_PATH]; char path3[_MAX_PATH]; 

	char path5[_MAX_PATH]; char path6[_MAX_PATH];

	char path7[_MAX_PATH];

	strcpy(path,srtpath);

	strcat(path,"dic1");

	strcpy(path1,srtpath);

    strcat(path1,"dic2");         

    strcpy(path2,srtpath);

    strcat(path2,"dic3");

	strcpy(path3,etcpath);

	strcat(path3,"frobs.txt");

	strcpy(path5,etcpath);

	strcat(path5,"sdic.");

	strcat(path5,name);

	strcat(path5,".");

	strcat(path5,LemmaName(LemmaGetScheme()));

	strcpy(path6,etcpath);

	strcat(path6,"streambase.");

	strcat(path6,name);

	strcat(path6,".");

	strcat(path6,LemmaName(LemmaGetScheme()));

	strcpy(path7,etcpath);

	strcat(path7,"qad.");

	strcat(path7,name);

	strcat(path7,".");

	strcat(path7,LemmaName(LemmaGetScheme()));

	corperr("Lemma scheme %s\n",LemmaName(LemmaGetScheme()));

	nd=0; nuses=0; nuses1=0;

	f=fopen(path,"w");                                  

	for (i=0;i<hashrange;i++)

		AddWords(i,f,&nd);

	fclose(f);

	sprintf(msg,"Found %li forms\n",nd);

	corperr(msg,"");

/*	mean=((double) nuses)/nd;

	sprintf(msg,"Mean frequency in BNC is %.2f\n",mean);

	corperr(msg,"");

	v=(nuses1-nd*mean*mean)/(nd-1);

	sd=sqrt(v);                                  

	sprintf(msg,"Sdev of frequency in BNC is %.2f\n",sd);

	corperr(msg,"");

	dh.mean=mean; dh.sd=sd;

*/

	sprintf(msg,"Number of word usages is %ld\n",nuses);

	corperr(msg,"");

	mysort1(path,path1,&nd);

	corperr("Sorted streambase\n");

	MakeStreambase(path1,path2,path6,&nd);

	corperr("Packed streambase nwt=%d\n",nwt);

	mysort2(path2,path5,nd);

	sprintf(msg,"Number of headwords is %d\n",nd);

	corperr(msg,"");

	dh.v0=dh.v1=0; dh.v2=1;

	dh.nw=nd; dh.nu=nuses;

//	sort1(path3,path4);

	remove(path3);

//	remove(path);                   

	corperr("Completed sort\n","");

	f=fopen(path2,"r");

	strcpy(dpath,etcpath);

	strcat(dpath,"dic.");

	strcat(dpath,name);

	strcat(dpath,".");

	strcat(dpath,LemmaName(LemmaGetScheme()));

	f1=fopen(dpath,"w");

	PackDict(f,f1,nd);         

	corperr("Dictionary complete\n","");

	fclose(f);

	fclose(f1);

	QADSave(path7);

	remove(path1); 

}	             







BOOL Headword(char* a,int tag,char* b,BOOL bFrob)

{

	return lemmata(a,tag,b,bFrob);

}





// void ProcessRecord1(char* w,struct strb *sb,FILE* f,long* nd)

void ProcessRecord1(char* w,struct strb *sb,FILE* f, int* nd)

{

	char hw[MAXWORD*2];

	if (!Headword(w,sb->extra,hw,sb->frobno != -1)) return;

	if (sb->wc==0) return; // only in subcorpora

	nuses+=sb->wc;

	fprintf(f,"%s\t%s\t%d %d %d %d %d %d %d %d %d %d" NL,hw,w,sb->wc,

		sb->type, sb->extra,sb->first,sb->ff,sb->last,sb->lf,sb->ihash,sb->frobno,sb->frobpos);

	(*nd)++;

}



//void ProcessRecord(char* w,struct strb *sb,FILE* f,long *nd)

void ProcessRecord(char* w,struct strb *sb,FILE* f,int *nd)

{

	int fi; BOOL bOK=(sb->type==ID_WORD 

		     && (sb->extra != HDRPOS || bNoPos));

	if (!bOK) return;

	fi=IsFrob(w);

	if (fi==-1) {

		sb->frobno=-1;

		sb->frobpos=0;

		ProcessRecord1(w,sb,f,nd);

#ifdef FROB

		FMUL(w,sb->extra,sb->wc);

#endif

	}

	else {

		int i;

		for (i=0;i<nfrobpos;i++) {

			if (fptab[i].frob != fi) continue;

			sb->frobno=i;

			sb->frobpos=fptab[i].offset;

			ProcessRecord1(fptab[i].word,sb,f,nd);

		}

	}

}





void AddWords(unsigned hi,FILE* f,int* nd)

{

	char path[_MAX_PATH]; FILE *fInd; struct strb sb;

	char oldw[MAXATTVAL+10];  int k=0; BOOL bOK=FALSE; int i;

	oldw[0]=0; sb.wc=0;

	sb.ihash=hi;

	do

	{

	  IndexFile(hi,k,path);

	fInd=fopen(path,"r");

	if (fInd==NULL) return;

	fread(&header,sizeof header,1,fInd);

	if (header.version != INDEXVER)

		{

		corperr("Index %s wrong format",path);

		fclose(fInd);

		return;

		}                 

	fread(dict,sizeof (struct dicent),header.ndict,fInd);

	fread(locs,sizeof (struct locent),header.nill,fInd);

	fread(words,1,header.nbytes,fInd);

	fclose(fInd);

	if (header.ndict==0) sb.wc+=SBCount(locs,header.nill);

	else

	{

	sb.wc+=SBCount(locs,dict[0].first);

	for (i=0;i<header.ndict;i++)       

		{

		char *w; 

		if (i > 0 || k > 0) {

			sb.lf=k;

			sb.last=dict[i].first;

			ProcessRecord(oldw,&sb,f,nd);

		}

		w=words+dict[i].dwd; 

		strcpy(oldw,w);

		sb.type=dict[i].type;

		sb.extra=dict[i].extra;

		sb.ff=k;

		sb.first=dict[i].first;

		if (i+1<header.ndict)

			sb.wc=SBCount(locs+dict[i].first,dict[i+1].first-dict[i].first);

		else

			sb.wc=SBCount(locs+dict[i].first,header.nill-dict[i].first);	

    	}	          

	}	

	k++;

	}

	while (header.bOS);

	sb.last=header.nill;

	sb.lf=k-1;

	ProcessRecord(oldw,&sb,f,nd);

	return;

}	                              















void PackDict(FILE* f,FILE* f1,long nd)

{                                 

	char s[MAXATTVAL+10]; long freq, str;

	struct di rec; int code=-1; int n=0; int j;

	fwrite(&dh,sizeof dh,1,f1);

	while (fscanf(f,"%[^\t] %d %d %*d\n",s,&freq,&str)==3)

	{

		int c0; unsigned char x0, x1;

		rec.w=WordTable(s);

		rec.freq=freq;

		rec.str=str;

		fwrite(&rec,sizeof rec,1,f1);

		x0=(unsigned char) s[0];

		x1=(unsigned char) s[1];

		if (x0==g_uc0) x0=1;

		if (x1==g_uc0) x1=1;

		c0=256*x0+x1;

		if (c0 != code) {

			for (j=code+1;j<=c0;j++) qad[j]=n;

			code=c0;

		}

		n++;

	}

	for (j=code+1;j<256*256;j++) qad[j]=n;

}		





		







BOOL Punct(int i)

{                            

	return postab[i].bPun;

}	

 











void PackIndex()

{                          

	int n; struct pihead ihdr; struct pii ipent;

	long koff; char code[MAX_CODE+1]; char id[10]; char path[_MAX_PATH];

	char ppath[_MAX_PATH];

	FILE *fPack;

	sprintf(ppath,"%s%s",etcpath,PINDEXNAME);

	fPack=fopen(ppath,"w");

	rewind(fIndex);

	n=0;

	while (fscanf(fIndex,"%s %s %s\n",code,id,path)==3) n++;

	ihdr.n=n;

	fwrite(&ihdr,sizeof ihdr,1,fPack);

	rewind(fIndex);

	koff=sizeof ihdr+n*sizeof ipent;

	while (fscanf(fIndex,"%s %s %s\n",code,id,path)==3)

	{

		strcpy(ipent.name,id);

		ipent.path=koff;

		koff+=strlen(path)+1;

		fwrite(&ipent,sizeof ipent,1,fPack);

	}                                       

	rewind(fIndex);	

	while (fscanf(fIndex,"%s %s %s\n",code,id,path)==3)

		fwrite(&path,1,strlen(path)+1,fPack);

	fclose(fPack);

}		





void IndexSig()

{                       

	char path[_MAX_PATH];

	struct index_sig is; FILE* f;

	strcpy(is.name,corpname);

	is.nelts=nelts;

	is.natts=natts;

	is.npos=npos;

	is.ntexts=ntexts;
	is.nhash=nhash;
	is.nhashsig=nhashsig;
	is.hashlast=hashlast;
	is.hashshift=hashshift;
	is.maxiloc=maxiloc;

	strcpy(path,etcpath);

	strcat(path,"index.sig");

	f=fopen(path,"w");

	if (f==NULL) return;

	fwrite(&is,sizeof is,1,f);

	fclose(f);

}





//#define MAXDICT 60000



struct _d {

	unsigned char* s1;

	unsigned char* s2;

	struct strb sb;

} ;

//d[MAXDICT];

	



int dc(const void* a1,const void* a2)

{

	struct _d* d1=(struct _d*) a1;

	struct _d* d2=(struct _d*) a2;

	return ustrcmp(d1->s1,d2->s1);

}





void mysort1(const char* p1,const char* p2,int *nd)

{

	FILE* f1=fopen(p1,"r");

	FILE* f2=fopen(p2,"w");

	char s[MAXATTVAL+10]; int i=0;

	char s1[MAXATTVAL+10]; int j;

	struct _d* d=(struct _d*) malloc(*nd*sizeof(struct _d));

	while (fscanf(f1,"%[^\t]\t%[^\t]\t %d %hd %hd %hd %hd %hd %hd %hd %hd %hd\n"

		,s,s1,&d[i].sb.wc,&d[i].sb.type,&d[i].sb.extra,

		&d[i].sb.first,&d[i].sb.ff,&d[i].sb.last,&d[i].sb.lf,

		&d[i].sb.ihash,&d[i].sb.frobno,&d[i].sb.frobpos)==12) {

//		if (i>MAXDICT) {

//			corperr("Dictionary full\n");

//			break;

//		}

		d[i].s1=malloc(strlen(s)+1);

		strcpy(d[i].s1,s);

		d[i].s2=malloc(strlen(s1)+1);

		strcpy(d[i].s2,s1);

		i++;

	}

	fclose(f1);

	qsort(d,i,sizeof(struct _d),dc);

	for (j=0;j<i;j++) {

		fprintf(f2,"%s\t%s\t%d %d %d %d %d %d %d %d %d %d" NL,d[j].s1,d[j].s2,

			d[j].sb.wc,d[j].sb.type,d[j].sb.extra,d[j].sb.first,d[j].sb.ff,

			d[j].sb.last,d[j].sb.lf,d[j].sb.ihash,d[j].sb.frobno,d[j].sb.frobpos);

		free(d[j].s1);

		free(d[j].s2);

	}

	*nd=i;

	fclose(f2);

	free(d);

}



	

struct _d2 {

	char* s;

	sara_int f, ff;

};



int dc2(const void* a1,const void* a2)

{

	struct _d2* d1=(struct _d2*) a1;

	struct _d2* d2=(struct _d2*) a2;

	if (d1->f != d2->f) return d2->f-d1->f;

	else return ustrcmp(d1->s,d2->s);

}





void mysort2(const char* p1,const char* p2,int nd)

{

	FILE* f1=fopen(p1,"r");

	FILE* f2=fopen(p2,"w");

	long f, ff; int j;

	char s[MAXATTVAL+10]; int i=0;

	struct _d2* d=(struct _d2*) malloc(nd*sizeof(struct _d2));

	while (fscanf(f1,"%[^\t] %d %*d %d\n",s,&f,&ff)==3) {

//		if (i>MAXDICT) {

//			corperr("Dictionary full\n");

//			break;

//		}

		d[i].s=malloc(strlen(s)+1);

		strcpy(d[i].s,s);

		d[i].f=(sara_int) f; d[i].ff=(sara_int) ff;

		i++;

	}

	fclose(f1);

	qsort(d,i,sizeof(struct _d2),dc2);

	for (j=0;j<i;j++) {

		fprintf(f2,"%s\t%ld %d" NL,d[j].s,d[j].f,d[j].ff);

		free(d[j].s);

	}

	fclose(f2);

	free(d);

}



	



void MakeStreambase(char* in,char* out1,char* sbpath,int* nw)

{

	FILE* fin, *fout, *fsb; struct strb sb, oldsb; char s[MAXWORD*2];

	char s1[MAXWORD*2]; char word[MAXWORD*2]; int k=0; int k1=0; int sbk=0; int sb0=0;

	BOOL bOld=FALSE;

	short x;

	fin=fopen(in,"r");

	fout=fopen(out1,"w");

	fsb=fopen(sbpath,"w");

	memset(&sb,0,sizeof sb);

	word[0]=0; *nw=0;

	while (fscanf(fin,"%[^\t]\t%[^\t]\t%d %hd %hd %hd %hd %hd %hd %hd %hd %hd\n"

		,s,s1,&sb.wc,&sb.type,&sb.extra,

		&sb.first,&sb.ff,&sb.last,&sb.lf,

		&sb.ihash,&x,&sb.frobpos)==12) {

		sb.frobno=x;

		if (strcmp(s,word)) {

			if (bOld) {

				fprintf(fout,"%s\t%d %d %d\n",word,k,sb0,k1);

				(*nw)++;

			}

			oldsb.bLast=TRUE;

			sb0=sbk+1;

			k=0; k1=0;

			strcpy(word,s);

		}

		if (bOld) {

			fwrite(&oldsb,sizeof sb,1,fsb);

			sbk++;

		}

		sb.word=WordTable(s1);

		sb.bLast=FALSE;

		k+=sb.wc; k1++;

		memcpy(&oldsb,&sb,sizeof sb);

		bOld=TRUE;

	}

	fprintf(fout,"%s\t%d %d %d\n",word,k,sb0, k1);

	(*nw)++;

	oldsb.bLast=TRUE;

	fclose(fout);

	fclose(fin);

	fclose(fsb);

//	corperr("Processing in-frob tags nfmtab=%d\n",nfmtab);

#ifdef FROB

	FMWrite();

#endif

//	corperr("Processed, returning\n");

}



int hashdfn(const char* s)

{

	int i, h; h=0;

	for (i=0;i<4;i++) {

		if (s[i]==0) break;

		h+=s[i]<<(5*i);

	}

	h &= 0xffff;

	return h;

}



#define WTMAX 4000000



struct _wt {

	char* s;

	sara_long ptr;

} wt[WTMAX];



int ht[0x10000];



int WTLookup(const char* s)

{

	int i; int h;

	h=hashdfn(s);

	i=ht[h];

	while (i!=-1) {

		if (!strcmp(wt[i].s,s)) return i;

		i=wt[i].ptr;

	}

	return -1;

}



int WTAdd(const char* s) 

{

	int i, h, j;

	h=hashdfn(s);

	i=nwt++;

	if (nwt >= WTMAX) {

		corperr("WT overflow\n");

		return 0;

	}

	wt[i].s=malloc(strlen(s)+1);

	strcpy(wt[i].s,s);

	wt[i].ptr=-1;

	if (ht[h]==-1) ht[h]=i; else {

		j=ht[h];

		while (wt[j].ptr != -1) {

			j=wt[j].ptr;

		}

		wt[j].ptr=i;

	}

	return i;

}





int WordTable(const char* s)

{

	int i=WTLookup(s);

	if (i != -1) return i;

	return WTAdd(s);

}



void WTLoad()

{

	char path[_MAX_PATH]; int k[2]; FILE* f; int i, j;

	WTInit();

	strcpy(path,etcpath);

	strcat(path,"wordbase");

	f=fopen(path,"r");

	fread(&nwt,sizeof nwt,1,f);

	for (i=0;i<nwt;i++) {

		int l=ftell(f); int h;

		fread(k,sizeof k,2,f);

		fseek(f,k[0],SEEK_SET);

		wt[i].s=malloc(k[1]-k[0]+1);

		fread(wt[i].s,1,k[1]-k[0],f);

		wt[i].s[k[1]-k[0]]=0;

		wt[i].ptr=-1;

		fseek(f,l+sizeof k[0],SEEK_SET);

		h=hashdfn(wt[i].s);

		if (ht[h]==-1) ht[h]=i;

		else {

			j=ht[h];

			while (wt[j].ptr != -1) {

				j=wt[j].ptr;

			}

			wt[j].ptr=i;

		}

	}

	fclose(f);

}



void WTFree()

{

	int i;

	for (i=0;i<nwt;i++)

		free(wt[i].s);

}







void WTSave()

{

	char path[_MAX_PATH]; int i; int k; FILE *f;

	strcpy(path,etcpath);

	strcat(path,"wordbase");

	f=fopen(path,"w"); k=(nwt+2)*sizeof (int);

	fwrite(&nwt,sizeof nwt,1,f);

	for (i=0;i<nwt;i++) {

		fwrite(&k,sizeof k,1,f);

		k+=strlen(wt[i].s);

	}

	fwrite(&k,sizeof k,1,f);

	for (i=0;i<nwt;i++) {

		fwrite(wt[i].s,1,strlen(wt[i].s),f);

		free(wt[i].s);

	}

	fclose(f);

	corperr("WT size is %d\n",nwt);

}



#ifdef FROB

#define NFMTABMAX 50000



struct _fm {

	char w[MAXWORD];

	sara_int pos;

	sara_int freq;

} fmtab[NFMTABMAX];







void FMUL(char* w, int extra,int f) 

{

	int i, j;

	for (i=0;i<nfrobpos;i++)

		if (!strcmp(fptab[i].word,w)) break;

	if (i==nfrobpos) return;

	for (j=0;j<nfmtab;j++) {

		if (!strcmp(fmtab[j].w,w) && fmtab[j].pos==extra) {

			fmtab[j].freq+=f;

			return;

		}

	}

	if (nfmtab>=NFMTABMAX-1) {

		printf("FMUL table has overflowed");

		return;

	}

	strcpy(fmtab[nfmtab].w,w);

	fmtab[nfmtab].pos=extra;

	fmtab[nfmtab].freq=f;

	nfmtab++;

}



int FMcomp(const void* v1,const void* v2)

{

	struct _fm* f1=(struct _fm*) v1;

	struct _fm* f2=(struct _fm*) v2;

	int k=strcmp(f1->w,f2->w);

	if (k) return k;

	return f2->freq-f1->freq;

}



void FMWrite() 

{

	char path[_MAX_PATH]; char o[MAXWORD]; FILE* f; int i;

	strcpy(path,etcpath);

	strcat(path,"fmul.txt"); 

	f=fopen(path,"w");

	o[0]=0;

	qsort(fmtab,nfmtab,sizeof (struct _fm),FMcomp);

	for (i=0;i<nfmtab;i++) {

		if (!strcmp(o,fmtab[i].w)) 

			fprintf(f," %s (%d)",postab[fmtab[i].pos].name,fmtab[i].freq);

		else {

			fprintf(f,"\n%s %s (%d)",fmtab[i].w,postab[fmtab[i].pos].name,fmtab[i].freq);

			strcpy(o,fmtab[i].w);

		}

	}

	fprintf(f,"\n");

	fclose(f);

}



#endif



void WTInit()

{

	int i;

	nwt=0;

	for (i=0;i<0x10000;i++)

		ht[i]=-1;

}





void QADSave(const char* path)

{

	FILE* f=fopen(path,"w");

	fwrite(qad,1,256*256*sizeof (int),f);

	fclose(f);

}



struct _lt {

	char w[MAXWORD];

	sara_int pos;

	char lw[MAXWORD];

};



#define MAXLTAB 100000



struct _lt* ltab[MAXLTAB];



int ClassifyPOS(char*);



int lc(const void* v1,const void* v2)

{

	struct _lt* lt1=* (struct _lt**) v1;

	struct _lt* lt2=* (struct _lt**) v1;

	int i=_stricmp(lt1->w,lt2->w);

	if (i!=0) return i;

	i=lt1->pos-lt2->pos;

	if (i!=0) return i;

	i=_stricmp(lt1->w,lt2->w);

	return i;

}



void MakeLemmaTable()

{

	char path[_MAX_PATH];

	char path1[_MAX_PATH];

	char line[1000]; int i;

	char w[MAXWORD]; char lw[MAXWORD]; char pos[100];

	struct _lt *lt; 

	int nl=0; FILE *f, *f1;

	strcpy(path,etcpath);

	strcat(path,"lemmata");

	strcpy(path1,etcpath);

	strcat(path1,"lemmata1");

	f = fopen(path,"r");

	while (fgets(line,sizeof line,f)) {

		int i, p; BOOL bNew=TRUE;

		sscanf(line,"%[^\t]\t%[^\t]\t%s",w,pos,lw);

		if (_stricmp(pos,"HDR")) p=HDRPOS;

		else p=ClassifyPOS(pos);

		for (i=0;i<nl;i++) {

			if (!strcmp(w,ltab[i]->w) && !strcmp(lw,ltab[i]->lw) && 

				ltab[i]->pos==p) {bNew=FALSE; continue;}

		}

		if (!bNew) continue;

		lt=malloc(sizeof *lt);

		strcpy(lt->w,w);

		strcpy(lt->lw,lw);

		lt->pos=p;

		ltab[nl++]=lt;

	}

	fclose(f);

	corperr("%d entries in forms table\n",nl);

	qsort(ltab,nl,sizeof (lt),lc);

	f1=fopen(path1,"w");

	for (i=0;i<nl;i++) 

		fprintf(f1,"%s\t%d\t%s\n",ltab[i]->w,ltab[i]->pos,ltab[i]->lw);

	fclose(f1);

}





