/*
 * $Id: endian.c,v 1.1 1996/02/15 01:30:08 scotty Rel $
 *
 * $Log: endian.c,v $
 * Revision 1.1  1996/02/15 01:30:08  scotty
 * Initial revision
 *
 */


#ifdef __unix__

#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <netinet/in.h>
#include "exttypes.h"
#if defined(CONV_NONE)
# undef  CONV_NONE
#endif /* CONV_NONE */
#if defined(CONV_INDEX)
# undef CONV_INDEX
#endif /* CONV_INDEX */
#if !defined(CONV_ALL)
# define CONV_ALL
#endif /* ! CONV_ALL */
#include "localize.h"



static char rcsid[] = "$Id: endian.c,v 1.1 1996/02/15 01:30:08 scotty Rel $";

sara_int letobe2(sara_int x)
{
	return ((x & 0xff) << 8) | ((x >> 8) & 0xff);
}

sara_long letobe4(sara_long x)
{
	return (letobe2((sara_int) (x & 0xffff)) << 16) | (letobe2((sara_int) (x >> 16)) & 0xffff);
}

void fix_accentry(struct accentry *data, int n)
{
   for (; n > 0; n--, data++) {
      data->x = letobe2(data->x);
      data->y = letobe2(data->y);
   }
}

void fix_bibhdr(struct bibhdr *data, int n)
{
   for (; n > 0; n--, data++) {
      data->type = letobe2(data->type);
      data->seek = letobe4(data->seek);
      data->nrows = letobe2(data->nrows);
   }
}

void fix_bibentry(struct bibentry *data, int n)
{
   for (; n > 0; n--, data++) {
      data->name = letobe4(data->name);
      data->namelen = letobe2(data->namelen);
   }
}

void fix_pihead(struct pihead *data, int n)
{
   for (; n > 0; n--, data++)
      data->n = letobe2(data->n);
}

void fix_pii(struct pii *data, int n)
{
   for (; n > 0; n--, data++)
      data->path = letobe4(data->path);
}

void fix_locent1(struct locent1 *data, int n)
{
   for (; n > 0; n--, data++) {
      data->bNew = letobe2(data->bNew);
      data->lcode = letobe4(data->lcode);
      data->pos = letobe4(data->pos);
      data->word = letobe4(data->word);
      data->lw = letobe2(data->lw);
   }
}

void fix_di(struct di *data, int n)
{
   for (; n > 0; n--, data++) {
      data->w = letobe4(data->w);
      data->freq = letobe4(data->freq);
      data->extra = letobe4(data->extra);
      data->str = letobe4(data->str);
   }
}

void fix_dhead(struct dhead *data, int n)
{
   int  *p;
   int   t;

   for (; n > 0; n--, data++) {
      data->v0 = letobe4(data->v0);
      data->v1 = letobe4(data->v1);
      data->v2 = letobe4(data->v2);
      data->nw = letobe4(data->nw);
      data->nu = letobe4(data->nu);
   }
}

void fix_strb(struct strb *data, int n)
{
   int  *p;
   int   t;

   for (; n > 0; n--, data++) {
      data->bLast = letobe2(data->bLast);
      data->word = letobe4(data->word);
      data->ihash = letobe2(data->ihash);
      data->type = letobe2(data->type);
      data->extra = letobe2(data->extra);
      data->ff = letobe2(data->ff);
      data->first = letobe2(data->first);
      data->lf = letobe2(data->lf);
      data->last = letobe2(data->last);
      data->frobpos = letobe2(data->frobpos);
      data->frobno = letobe2(data->frobno);
      data->wc = letobe4(data->wc);

   }
}

void fix_sara_long(sara_long *data, int n)
{
   for (; n > 0; n--, data++)
      *data = letobe4(*data);
}

void fix_sara_ulong(sara_ulong *data, int n)
{
   for (; n > 0; n--, data++)
      *data = letobe4(*data);
}

void fix_sara_int(sara_int *data, int n)
{
   for (; n > 0; n--, data++)
      *data = letobe2(*data);
}

void fix_dicent(struct dicent *data, int n)
{
   for (; n > 0; n--, data++) {
      data->dwd = letobe2(data->dwd);
      data->type = letobe2(data->type);
      data->extra = letobe2(data->extra);
      data->first = letobe2(data->first);
   }
}

void fix_ihdr(struct ihdr *data, int n)
{
   for (; n > 0; n--, data++) {
      data->version = letobe2(data->version);
      data->ndict = letobe2(data->ndict);
      data->nill = letobe2(data->nill);
      data->nbytes = letobe2(data->nbytes);
      data->bOS = letobe2(data->bOS);
   }
}

void fix_locent(struct locent *data, int n)
{
   for (; n > 0; n--, data++) {
      data->bNew = letobe2(data->bNew);
      data->lcode = letobe4(data->lcode);
      data->pos = letobe4(data->pos);
      data->word = letobe4(data->word);
   }
}

void fix_sig(struct index_sig *data,int n)
{
	for (; n > 0;n--,data++) {
		data->nelts=letobe2(data->nelts);
		data->natts=letobe2(data->natts);
		data->npos=letobe2(data->npos);
		data->ntexts=letobe4(data->ntexts);
		data->nhash=letobe2(data->nhash);
		data->nhashsig=letobe2(data->nhashsig);
		data->hashshift=letobe2(data->hashshift);
		data->hashlast=letobe2(data->hashlast);
		data->maxiloc=letobe2(data->maxiloc);
	}
}						

#endif  /* __unix__ */
