/*
 * $Id: solve.c,v 1.5 1996/05/12 23:36:15 scotty Rel $
 *
 * $Log: solve.c,v $
 * Revision 1.5  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.4  1996/03/01 23:55:32  scotty
 * Changed bcopy to memcpy since some systems don't have bcopy
 * by default (esp. Solaris).
 *
 * Revision 1.3  1996/02/26 22:23:46  scotty
 * Now includes string.h to keep gcc happy.
 *
 * Revision 1.2  1996/02/26 21:11:48  scotty
 * Changed the definition of BNC_PORT so that it can be overridden by
 * the Makefile.
 *
 * Revision 1.1  1996/02/15 02:21:46  scotty
 * Initial revision
 *
 */
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

static char rcsid[] = "$Id: solve.c,v 1.5 1996/05/12 23:36:15 scotty Rel $";

#define BNC_SERVER "quirk.oucs.ox.ac.uk"

#if !defined(BNC_PORT)
# define BNC_PORT 7001
#endif

struct sockaddr_in active;

char cc[4000];
char ccc[4000];

main(int argc, char **argv)
{
   int             s;
   int             i;
   int             e;
   int             n;
   int             k;
   struct hostent *hp;

   if (argc != 2) {
      printf("Usage: solve cql-query\n");
      exit(1);
   }

   hp = gethostbyname(BNC_SERVER);
   if (hp == 0) {
      printf("Unknown host %s\n",BNC_SERVER);
      return 1;
   }
   memcpy((char *)&active.sin_addr, (char *)hp->h_addr, hp->h_length);
   active.sin_family = AF_INET;
   active.sin_port = htons(BNC_PORT);
   s = socket(AF_INET, SOCK_STREAM, 0);
   e = connect(s, (struct sockaddr *)&active, sizeof(active));
   if (e == 0)
      printf("Connected!");
   else {
      perror("connect()");
      exit(1);
   }
   strcpy(cc, "LOG guest guest");
   write(s, cc, strlen(cc) + 1);
   k = read(s, ccc, sizeof(ccc));
   strcpy(cc, "SOLVE foo ");
   strcat(cc, argv[1]);
   write(s, cc, strlen(cc) + 1);
   k = read(s, ccc, sizeof(ccc));

   n = 0;
   sscanf(ccc, "OK %d", &n);
   strcpy(cc, "FILTER foo NOSGMLX");
   write(s, cc, strlen(cc) + 1);
   k = read(s, ccc, sizeof(ccc));
   strcpy(cc, "FILTER foo NORMSPACE");
   write(s, cc, strlen(cc) + 1);
   k = read(s, ccc, sizeof(ccc));
   printf("%d solutions\n", n);

   for (i = 0; i < n; i++) {
      sprintf(cc, "GET foo %d s", i);
      write(s, cc, strlen(cc) + 1);
      k = read(s, ccc, sizeof(ccc));
      ccc[k] = 0;
      printf("%s\n", ccc);
   }
   strcpy(cc, "LOGOUT");
   write(s, cc, strlen(cc) + 1);
   close(s);
}

